// Sound.h: interface for the CMusic class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUND_H__059C1385_B742_423A_A1FC_270807551F44__INCLUDED_)
#define AFX_SOUND_H__059C1385_B742_423A_A1FC_270807551F44__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct	SAudio {
	
	DWORD					m_dwID;
	IDirectMusicSegment8*	m_lpSegment;
};

class CMusic 
{
private:
	IDirectMusicLoader8*		m_lpDMLoader;
	IDirectMusicPerformance8*	m_lpDMPerformance;

	CPtrArray					m_arSegments;

	int		m_MusicVolume;
	BOOL	m_bInit;

public:
	// Initialization
	void	CreateDirectMusicSystem(HWND hWnd);
	void	DeinitMusic();
	//
	// Get music from MIDI or WAV
	void	LoadMusicFromFile(DWORD dwID, CString BMPFile);
	//
	// Music/sounds play & stop functions
	void PlayMusic(DWORD dwID);
	void PlaySound(DWORD dwID);
	void StopMusic(DWORD dwID);
	//
	// Master volume
	void IncreaseMusicVolume();
	void DecreaseMusicVolume();
	int  GetMusicVolume() {return  m_MusicVolume;}

public:	
	CMusic();
	~CMusic();
};

#endif // !defined(AFX_SOUND_H__059C1385_B742_423A_A1FC_270807551F44__INCLUDED_)
