// Sound.cpp: implementation of the CSound class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Sound.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSound::CSound()
{
	m_lpDS = NULL;

	for(int i = 0; i < DS_MAX_SOUNDS; i++)
		m_lpDSBSound[i] = NULL;

	m_SoundVolume = 0;
}

CSound::~CSound()
{
	SAFE_RELEASE(m_lpDS);

	for(int i = 0; i < DS_MAX_SOUNDS; i++)
		ReleaseSound(i);
}

void CSound::Deinit()
{

}


void CSound::CreateDirectSoundSystem(HWND hWnd)
{
  /*  if(DirectSoundCreate(NULL, &m_lpDS, NULL) != DS_OK) {
		WriteLogString("Object DirectSound could not be create");
		TRACE("Object DirectSound could not be create\n");
		return;
	}
     */ 
    if(m_lpDS->SetCooperativeLevel(hWnd, DSSCL_PRIORITY) != DS_OK) {
//		WriteLogString("Cooperative level for DirectSound could not be set");
		TRACE("Cooperative level for  DirectSound could not be set\n");
		return;
	}
	// Obtain primary buffer
	DSBUFFERDESC                dsbdesc;
	
    ZeroMemory(&dsbdesc, sizeof(DSBUFFERDESC));
    dsbdesc.dwSize = sizeof(DSBUFFERDESC);
    dsbdesc.dwFlags = DSBCAPS_PRIMARYBUFFER | DSBCAPS_LOCHARDWARE | DSBCAPS_CTRLVOLUME;

    if(m_lpDS->CreateSoundBuffer(&dsbdesc, &m_lpDSBPrimary, NULL) != DS_OK) {
	//	WriteLogString("CreateSoundBuffer could not be create");
		TRACE("CreateSoundBuffer could not be create\n");
		return;
	}
    
    // Set primary buffer format
 
    WAVEFORMATEX wfx;
    memset(&wfx, 0, sizeof(WAVEFORMATEX)); 
    wfx.wFormatTag = WAVE_FORMAT_PCM; 
    wfx.nChannels = 2; 
    wfx.nSamplesPerSec = 44100; 
    wfx.wBitsPerSample = 16; 
    wfx.nBlockAlign = wfx.wBitsPerSample / 8 * wfx.nChannels;
    wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;
 
    if(m_lpDSBPrimary->SetFormat(&wfx) != DS_OK) {
	//	WriteLogString("SetFormat for primary buffer could not be set");
		TRACE("SetFormat for primary buffer could not be set\n");
		return;
	}
}

void CSound::LoadSoundFromFile(CString WAVFile)
{
/*	CWaveFile WF;

	for(int i = 0; i < DS_MAX_SOUNDS; i++) {
		if(m_lpDSBSound[i] ==  NULL)
			break;
	}
	ASSERT(i < DS_MAX_SOUNDS);

    WAVEFORMATEX pcmwf; 
    DSBUFFERDESC dsbdesc; 

	WAVFile = "D:\\Jirka\\Programy ve C++ 6.0\\Current Projects\\Rocket - DirectDraw\\sounds\\" + WAVFile;

	if(WF.Open(WAVFile.GetBuffer(0), &pcmwf, WAVEFILE_READ) != S_OK) {
		TRACE("Open is not ready\n");
		return;
	}
 
    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC)); 
	dsbdesc.dwSize = sizeof(DSBUFFERDESC); 
	dsbdesc.dwFlags = /*DSBCAPS_STATIC   |*/ DSBCAPS_CTRLVOLUME  ; 
	/*dsbdesc.dwBufferBytes = WF.GetSize(); 
	dsbdesc.lpwfxFormat = WF.m_pwfx; 
 
	DD_VERIFY(m_lpDS->CreateSoundBuffer(&dsbdesc, &m_lpDSBSound[i], NULL),
				"Buffer for user sound could not be created\n");	

	LPVOID lpvAudio1;
	DWORD  dwBytes1;
	DWORD dwBytesRead;

	if(m_lpDSBSound[i]->Lock(
			0,              // Offset of lock start.
			0,              // Size of lock; ignored in this case.
			&lpvAudio1,     // Address of lock start.
			&dwBytes1,      // Number of bytes locked.
			NULL,           // Wraparound start; not used.
			NULL,           // Wraparound size; not used.
			DSBLOCK_ENTIREBUFFER) != DS_OK) {
		TRACE("Lock on secondary buffer was in prdel\n");
		return;
	}

 
	if(WF.Read((BYTE*)lpvAudio1, dwBytes1, &dwBytesRead) != S_OK) {
		TRACE("Read selhal \n");
		return;
	}
 
	m_lpDSBSound[i]->Unlock(lpvAudio1, dwBytes1, NULL, 0);
	WF.Close();
*/
}

void CSound::PlaySound(UINT ID)
{
	ASSERT(ID < DS_MAX_SOUNDS);

	if(!m_lpDSBSound[ID])
		return;

	m_lpDSBSound[ID]->Stop();
	m_lpDSBSound[ID]->SetCurrentPosition(0);

	if(m_lpDSBSound[ID]->Play(0, 0, 0) != DS_OK) {
		TRACE("Play is not ready\n");
	}
}

void CSound::StopSound(UINT ID)
{
	ASSERT(ID < DS_MAX_SOUNDS);

	if(!m_lpDSBSound[ID])
		return;

	m_lpDSBSound[ID]->Stop();
}

void CSound::ReleaseSound(UINT ID)
{
	ASSERT(ID < DS_MAX_SOUNDS);

	if(!m_lpDSBSound[ID])
		return;

//	SAFE_RELEASE(m_lpDSBSound[ID]);
}


void CSound::SetSoundVolume(int Volume)
{
	for(int i = 0; i < DS_MAX_SOUNDS; i++) {
		if(m_lpDSBSound[i]) {
			m_lpDSBSound[i]->SetVolume(Volume);
		}
	}

	m_SoundVolume = Volume;
}

void CSound::DecreaseSoundVolume()
{
	int Volume = m_SoundVolume;

	Volume -= 50;

	if(Volume <= -5000)
		Volume = -5000;

	for(int i = 0; i < DS_MAX_SOUNDS; i++) {
		if(m_lpDSBSound[i]) {
			m_lpDSBSound[i]->SetVolume(Volume);
		}
	}
	m_SoundVolume = Volume;
}



void CSound::IncreaseSoundVolume() 
{
	int Volume = m_SoundVolume;

	Volume += 50;

	if(Volume >= 0)
		Volume = 0;

	for(int i = 0; i < DS_MAX_SOUNDS; i++) {
		if(m_lpDSBSound[i]) {
			m_lpDSBSound[i]->SetVolume(Volume);
		}
	}
	m_SoundVolume = Volume;
}















