// Sound.h: interface for the CSound class.
//
//////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// Name: class CWaveFile
// Desc: Encapsulates reading or writing sound data to or from a wave file
//-----------------------------------------------------------------------------

#if !defined(AFX_SOUND1_H__A890EBC7_E615_4A27_9B72_3A70970BCEA2__INCLUDED_)
#define AFX_SOUND1_H__A890EBC7_E615_4A27_9B72_3A70970BCEA2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DS_MAX_SOUNDS	10

#include "..\Common\Common.h"

class CSound  
{
public: 
	IDirectSound	*		m_lpDS;
private:
	IDirectSoundBuffer*	m_lpDSBPrimary;

	IDirectSoundBuffer* m_lpDSBSound[DS_MAX_SOUNDS];

	int m_SoundVolume;
public:
	void CreateDirectSoundSystem(HWND hWnd);

	//getting sound from file
	void LoadSoundFromFile(CString WAVFile);

	//play & stop functions
	void PlaySound(UINT ID);
	void StopSound(UINT ID);
	void ReleaseSound(UINT ID);

	//volume functions
	void SetSoundVolume(int Volume);
	void DecreaseSoundVolume();
	void IncreaseSoundVolume();
	int  GetSoundVolume() {return m_SoundVolume;}

public:
	void Deinit();
	CSound();
	virtual ~CSound();

};

#endif // !defined(AFX_SOUND1_H__A890EBC7_E615_4A27_9B72_3A70970BCEA2__INCLUDED_)
