// Specializace.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream.h>
#include <string.h>

template<class T> class Container {
private:
	T m_pole[20];
public:
	Container();
	VlozDoPole(int _index, T _prvek);
	T VyberZPole(int _index);
};

template<class T> Container<T>::Container()
{
	for(int i = 0; i < 20; i++)
	{
		m_pole[i] = 0;	// inicializace
	}
};

template<class T> Container<T>::VlozDoPole(int _index, T _prvek)
{
	if(_index < 20)	// Jsme-li v poli
	{
		m_pole[_index] = _prvek;
	}
};

template<class T> T Container<T>::VyberZPole(int _index)
{
	if(_index < 20)
	{
		return m_pole[_index];
	}
	else
	{
		return 0;
	}
};

template<> class Container<char*> {
private:
    char* m_pole[20];
public:
    Container();
    ~Container();
    VlozDoPole(int _index, char* _prvek);
    char* VyberZPole(int _index);
};

template<> Container<char*>::Container()
{
	for(int i = 0; i < 20; i++)
	{
		m_pole[i] = NULL;
	}
}

template<> Container<char*>::~Container()
{
	for(int i = 0; i < 20; i++)
	{
		delete m_pole[i];
	}
}

template<> Container<char*>::VlozDoPole(int _index, char* _prvek)
{
	if(_index < 20)
	{
		int ilen = strlen(_prvek) + 1;

		m_pole[_index] = new char[ilen];

		if(m_pole[_index])
		{
			strcpy(m_pole[_index], _prvek);
		}
	}
}

template<> char* Container<char*>::VyberZPole(int _index)
{
	if(_index < 20)
	{
		return m_pole[_index];
	}
	else
	{
		return NULL;
	}
}

int main(int argc, char* argv[])
{
	Container<int> intCont;

	for(int i = 0; i < 20; i++)
	{
		cout << intCont.VyberZPole(i) << " ";
	}

	cout << endl;

	Container<char *> stringCont;

	char* retezec = new char[5];

	strcpy(retezec, "TEST");

	stringCont.VlozDoPole(0, retezec);

	retezec[3] = 'A';	// zmeni data

	for(i = 0; i < 20; i++)
	{
		char* lpprvek = stringCont.VyberZPole(i);
		if(lpprvek)
		{
			cout << lpprvek << " ";
		}
		else
		{
			cout << "Nic ";
		}
	}

	char c;
	cin >> c;

	return 0;
}
